diff -BbruN freeswan-1.91.orig/doc/pkix/openssl-ca.quickstart freeswan-1.91/doc/pkix/openssl-ca.quickstart
--- freeswan-1.91.orig/doc/pkix/openssl-ca.quickstart	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/doc/pkix/openssl-ca.quickstart	Mon Jun 18 16:35:38 2001
@@ -0,0 +1,268 @@
+This document is much like a quickstart, but in an even shorter form.
+These are the steps I took to create an opensourced CA capable of signing 
+certificates.
+
+How I set up a CA on RedHat 6.2 and used it:
+
+
+1- install openssl on the CA. 
+If the openssl package is already installed, then ignore this 
+section. Please note: requires 0.9.5a. I doubt FreeSWAN will
+run with openssl 0.9.6.
+----------------------------------------------------------------
+cd /usr/src/redhat/SRPMS
+scp root@10.8.49.101:/usr/src/redhat/SRPMS/openssl*.src.rpm .
+rpm --rebuild openssl-0.9.5a-1.src.rpm
+cd ../RPMS/i386/
+rpm -i openssl-*
+
+
+2- Setting up the openssl CA.
+The openssl RPM already create a /var/lib/ssl directory. If you installed
+openssl from source, look for it in either /usr/ssl, /usr/local/ssl,
+or even /usr/share/ssl.
+----------------------------------------------------------------
+cd /var/lib/ssl
+# Note! Newer redhat openssl RPMs created the dir in /usr/share/ssl
+
+# will simplify finding global conf files.
+ln -s /etc etc 
+
+# see README.certificates, section 4.1, for instructions
+# on the creation/addition of openssl.cnf 
+# Note! Since Redhat redid its openssl packages, openssl.cnf is present.
+# Use it instead.
+vi /etc/openssl.cnf
+
+# see README.certificates, section 4.1, for instructions
+# on the CA extensions to define in ca.ext
+vi ca.ext 
+
+openssl req -new -newkey rsa:1024 -keyout \
+	private/cakey.pem -out careq.pem
+# Please enter in a password to be able to use the CA's signing cert once 
+# it is generated. Only that password will unlock it for use.
+# Data may be asked of you to enter.
+# ____________________________________________________________________
+# --- Country Name (2 letter code) [AU]:
+# --- State or Province Name (full name) [Some-State]:
+# --- Locality Name (eg, city) []:
+# **important** The OrgName must match on ALL certs which will be signed
+# by this self-signed cert.
+#   --- Organization Name (eg, company) [Internet Widgits Pty Ltd]:
+# --- Organizational Unit Name (eg, section) []:
+# **Note** Try to use the machine's FQDN as common name. Not your own
+# name. :
+#   --- Common Name (eg, your name or your server's hostname) []:
+# --- Email Address []:
+# ____________________________________________________________________
+#
+# Unimportant:
+# Please enter the following 'extra' attributes
+# to be sent with your certificate request
+# A challenge password []:
+# An optional company name []:
+
+# sign our own CA certificate.
+openssl x509 -CAcreateserial -signkey private/cakey.pem -req \
+	-in careq.pem -out cacert.pem -days 2000 -extfile ca.ext
+
+touch index.txt
+echo "01" > serial
+openssl ca -gencrl -out crl.pem; # distribute/make available to all hosts.
+
+
+3- adding cacert.pem and crl.pem to hosts (OPTIONAL)
+Unless you are using LDAP lookup, you will have to make the certificate
+available on all the client hosts. Of course, make sure the destination 
+directory exists.
+----------------------------------------------------------------
+scp crl.pem 10.1.49.233:/etc/ipsec
+scp cacert.pem 10.1.49.233:/etc/ipsec
+scp crl.pem 10.8.49.101:/etc/ipsec
+scp cacert.pem 10.8.49.101:/etc/ipsec
+
+
+4- Each client host -- generate certificate requests.
+The CA's signing certificate is ready. Now we can create the client
+certificates. 
+NOTE: a CA can also be its own client if a separate certificate
+is generated. Both the cacert.pem and the host certificates must be
+made available as standard host certificates, as if they were 2 separate
+hosts.
+----------------------------------------------------------------
+mkdir -p /etc/ipsec
+cd /etc/ipsec
+
+# Make sure the info entered for the "CommonName" for each client 
+#   is DIFFERENT, usually containing the hostname.
+# Make sure the "OrgName" used is the same as the one used 
+#   for cacert.pem's creation.
+# Make sure you don't create this certificate with a password.
+#  This certificate must be available for use without user intervention.
+#  (that includes password entry)
+openssl req -new -newkey rsa:1024 -nodes -keyout \
+	`hostname`.key -out `hostname`.req.pem
+############################
+# OR DSA: (still unsupported. left note in to remember how to do it)
+# openssl dsaparam 1024 -out dsa_params.txt
+# chmod 400 dsa_params.txt
+#openssl req -new -newkey dsa:dsa_params.txt -nodes -keyout \
+#        /etc/ipsec/`hostname`.key -out /etc/ipsec/`hostname`.req.pem
+#remember that all parties must use DSA
+############################
+
+# how about a generic name on each host for ease?
+ln -fs `hostname`.key privkey.pem
+ln -fs `hostname`.pem pubcert.pem; # will be created soon.
+
+# protect the private key.
+chmod 400 `hostname`.key
+
+
+
+5- Signing certificates on the CA host
+Signing the certificates is a necessary step in the pkix CA setup,
+but first, you must give your CA the ability.
+You may find the signIPSEC script handy.
+----------------------------------------------------------------
+###########################
+# Create/Undate the following ONCE.
+# Once again, note the paths may be wrong.
+vi /etc/openssl.cnf; # (see README.certificates section 4.6)
+
+# Either create signIPSEC, or copy it from the current directory.
+#   to /usr/local/bin on the CA host.
+vi /usr/local/bin/signIPSEC; # (see README.certificates section 4.6)
+
+chmod 700 /usr/local/bin/signIPSEC
+# use: signIPSEC foo.mydomain.com 192.168.1.5 foo.req
+
+# Once again, CD to the correct path.
+cd /var/lib/ssl/
+mkdir -p newcerts
+
+# The following steps can be reused over and over, for each host to add
+#
+# 1- copy over the unsigned public cert from the host.
+scp root@10.1.49.233:/etc/ipsec/*.req.pem .
+#
+# 2- sign it with the correct values.
+signIPSEC sticky.netwinder.org 10.1.49.233 sticky.req.pem
+#
+# 3- copy the newly signed certificate to the host.
+scp newcerts/`cat serial.old`.pem root@10.1.49.233:/etc/ipsec/sticky.pem
+#
+# 4- rehash the current database of certificates handled by the CA.
+mv newcerts/* certs/
+c_rehash certs
+
+
+
+6- CA host: prepping flat file for client hosts
+Here's a short script for quick generations of text flatfiles needed
+by the various clients. LDAP lookup is prefered, but flatfile is available
+for testing or simplicity.
+The script is available as "CA-regenerate-flatfile.sh".
+----------------------------------------------------------------
+#!/bin/sh -x
+
+if [ -d /var/lib/ssl ]; then
+  cd /var/lib/ssl
+elif [ -d /usr/lib/ssl ]; then
+  cd /usr/lib/ssl
+elif [ -d /usr/local/lib/ssl ]; then
+  cd /usr/local/lib/ssl
+elif [ -d /usr/share/ssl ]; then
+  cd /usr/share/ssl
+else
+  echo "ERROR: Cannot determine location of ssl directory."
+  exit 1
+fi
+
+cat /dev/null > flatfile.txt
+
+for ii in certs/*.pem cacert.pem crl.pem;
+do
+  if [ "`basename $ii`" != "crl.pem" ] && [ "`basename $ii`" != "cacert.pem" ];
+  then
+    perl -e "open(IN, \"openssl x509 -in $ii -noout -text \|\"); \
+      @IN = <IN>; \
+      foreach (@IN) { \
+        if (/IP Address:(\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3})/) { \
+          print \"ip: \$1\\n\"; \
+        } \
+        if (/DNS:([^, ]*).*$/) { \
+          print \"dns: \$1\\n\"; \
+        } \
+      };" >> flatfile.txt
+  fi
+  cat $ii | \
+  perl -e '$printme = 0; while (<>) { if (/---BEGIN/) {$printme = 1;}; if ($printme) {print STDOUT $_;} }; print STDOUT "\n";' \
+  >> flatfile.txt
+done
+----------------------------------------------------------------
+
+# the flatfile is created. Send to Client hosts.
+scp flatfile.txt root@10.1.49.233:/etc/ipsec
+scp flatfile.txt root@10.8.49.101:/etc/ipsec
+
+
+
+7- revoking a certificate
+Sometimes it becomes necessary to revoke a certificate. 
+----------------------------------------------------------------
+# First, find out which certificate has to be revoked. If properly
+# generated, the CommonName (CN) will be the certificate's owner 
+# hostname. Replace "WANTED_HOSTNAME" by the hostname to look for.
+cd /var/lib/ssl/
+(
+for certs in certs/*.pem; do 
+  echo -n "$certs: " 
+  openssl x509 -in $certs -noout -subject
+done
+) | grep WANTED_HOSTNAME
+
+# Example output:
+# 02.pem: subject=/C=CA/ST=Ontario/O=Rebel.com/OU=SoftEng/CN=arm1.netwinder.org/Email=firesoul@netwinder.org
+
+# next, proceed to revoke the certificate.
+# once again, double-check the paths.
+openssl ca -revoke /var/lib/ssl/certs/02.pem 
+openssl ca -gencrl -out /var/lib/ssl/crl.pem
+
+# If we're using LDAP, the new crl.pem will be used automatically.
+# Otherwise, it has to be copied to each one of the client hosts.
+scp crl.pem root@10.1.49.233:/etc/ipsec
+scp crl.pem root@10.8.49.101:/etc/ipsec
+
+
+8- converting to and from PKCS#7 enveloped certificates
+
+  From PKCS7 in PEM format to certificates:
+    openssl pkcs7 -in x86rack1.pk7 -print_certs -inform PEM
+  From PKCS7 in DER format to certificates:
+    openssl pkcs7 -in x86rack1.pk7 -print_certs -inform DER
+
+  From certificate (with available CRL) to DER PKCS7:
+    openssl crl2pkcs7 -in dir/crl.pem -certfile x86rack1.pem -outform DER \
+      -out x86rack1.pk7
+  From certificate (no crl) to DER PKCS7:
+    openssl crl2pkcs7 -nocrl -certfile x86rack1.pem -outform DER \
+      -out x86rack1.pk7
+
+Sending with CRL gives an idea what your CA is from the other end's 
+perspective. Using that info, cross referencing can occur and a
+connection be established despite being registered on different CAs.
+
+
+9- converting to and from PKCS#12 "bag"s.
+
+  Extracting private key from PKCS12 in DER format:
+    openssl pkcs12 -in x86rack1.p12 -nocerts -out x86rack1.key
+  Extracting public certificate(s) from PKCS12 in DER format:
+    openssl pkcs12 -in x86rack1.p12 -nokeys -out x86rack1.pem
+
+  Creating a PKCS12 file:
+    openssl pkcs12 -export -in x86rack1.pem -inkey x86rack1.key  \
+      -des3 -name "my pkcs12" -out x86rack1.p12
diff -BbruN freeswan-1.91.orig/doc/pkix/signIPSEC freeswan-1.91/doc/pkix/signIPSEC
--- freeswan-1.91.orig/doc/pkix/signIPSEC	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/doc/pkix/signIPSEC	Mon Jun  4 11:34:31 2001
@@ -0,0 +1,38 @@
+#!/bin/bash
+
+# Simple wrapper for "openssl ca" that sets environment to pass in
+# values for the svr_cert extension
+# P.J.Onion  23/9/1999
+# updated by: Luc Lanthier   20010214
+if [ -d /var/lib/ssl ]; then
+  SSLDIR="/var/lib/ssl";
+elif [ -d /usr/lib/ssl ]; then
+  SSLDIR="/usr/lib/ssl";
+elif [ -d /usr/local/lib/ssl ]; then
+  SSLDIR="/usr/local/lib/ssl";
+elif [ -d /usr/share/ssl ]; then
+  SSLDIR="/usr/share/ssl";
+else
+  echo "ERROR: Cannot determine location of ssl directory."
+  exit 1
+fi
+
+
+if test $# -ne 3 ; then
+        echo "Usage: $0 hostname ipaddress reqfile"
+        exit 1
+fi
+
+
+HOSTFQDN=$1
+HOSTIP=$2
+NSCOMMENT="IPsec Certificate for $1"
+EXTENSION=svr_cert
+
+export HOSTFQDN HOSTIP NSCOMMENT EXTENSION
+if (which openssl &> /dev/null) ; then
+  openssl ca -in $3
+else
+  echo "ERROR: Cannot locate/execute openssl binary."
+  exit 1
+fi
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/Config.in freeswan-1.91/klips/net/ipsec/Config.in
--- freeswan-1.91.orig/klips/net/ipsec/Config.in	Thu Jun 14 15:35:07 2001
+++ freeswan-1.91/klips/net/ipsec/Config.in	Mon Jul  2 20:30:27 2001
@@ -27,6 +27,7 @@
 bool '   IPSEC: Encapsulating Security Payload' CONFIG_IPSEC_ESP
 if [ "$CONFIG_IPSEC_ESP" = "y" ]; then
   bool '      3DES encryption algorithm' CONFIG_IPSEC_ENC_3DES
+  bool '      DES encryption algorithm' CONFIG_IPSEC_ENC_DES
 fi
 
 bool '   IPSEC: IP Compression' CONFIG_IPSEC_IPCOMP
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/Makefile freeswan-1.91/klips/net/ipsec/Makefile
--- freeswan-1.91.orig/klips/net/ipsec/Makefile	Thu Jun 14 15:35:07 2001
+++ freeswan-1.91/klips/net/ipsec/Makefile	Mon Jul  2 20:31:23 2001
@@ -57,6 +57,7 @@
 EXTRA_CFLAGS += -Wbad-function-cast 
 
 obj-$(CONFIG_IPSEC_ENC_3DES) += libdes/libdes.a
+obj-$(CONFIG_IPSEC_ENC_DES) += libdes/libdes.a
 obj-$(CONFIG_IPSEC_AUTH_HMAC_MD5) += ipsec_md5c.o
 obj-$(CONFIG_IPSEC_AUTH_HMAC_SHA1) += ipsec_sha1.o
 obj-$(CONFIG_IPSEC_IPCOMP) += ipcomp.o zlib/zlib.a
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/ipsec_esp.h freeswan-1.91/klips/net/ipsec/ipsec_esp.h
--- freeswan-1.91.orig/klips/net/ipsec/ipsec_esp.h	Thu Jun 14 15:35:08 2001
+++ freeswan-1.91/klips/net/ipsec/ipsec_esp.h	Mon Jul  2 20:37:04 2001
@@ -40,6 +40,27 @@
 #define DB_ES_OH	0x0400
 #define DB_ES_REPLAY	0x0800
 
+struct espdesold_xdata
+{
+       int     edx_ivlen;              /* 4 or 8 */
+       union
+       {
+               __u8    Iv[8];          /* that's enough space */
+               __u32   Ivl[2];
+               __u64   Ivq;
+       }Iu;
+#define edx_iv Iu.Iv
+#define edx_ivl Iu.Ivl
+#define edx_ivq Iu.Ivq
+       union
+       {
+               __u8 Rk[8];
+               __u32 Eks[16][2];
+       }Xu;
+#define edx_rk Xu.Rk
+#define edx_eks        Xu.Eks
+};
+
 struct espblkrply_edata
 {
 	__u16	eme_klen;		/* encryption key length */
@@ -64,6 +85,19 @@
 };
 
 #ifdef __KERNEL__
+struct espdesmd5_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
+       MD5_CTX edmx_ictx;              /* derived from HMAC_key */
+       MD5_CTX edmx_octx;              /* ditto */
+};
+
 struct esp3desmd5_xdata
 {
 	__u8	edmx_flags;		/* same as before */
@@ -89,6 +123,19 @@
 	MD5_CTX edmx_octx;		/* ditto */
 };
 
+struct espdessha1_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
+       SHA1_CTX edmx_ictx;             /* derived from HMAC_key */
+       SHA1_CTX edmx_octx;             /* ditto */
+};
+
 struct esp3dessha1_xdata
 {
 	__u8	edmx_flags;		/* same as before */
@@ -112,6 +159,17 @@
 	__u32	edmx_lastseq;		/* in host order */
 	SHA1_CTX edmx_ictx;		/* derived from HMAC_key */
 	SHA1_CTX edmx_octx;		/* ditto */
+};
+
+struct espdes_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
 };
 
 struct esp3des_xdata
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/ipsec_rcv.c freeswan-1.91/klips/net/ipsec/ipsec_rcv.c
--- freeswan-1.91.orig/klips/net/ipsec/ipsec_rcv.c	Wed Jun 13 16:58:40 2001
+++ freeswan-1.91/klips/net/ipsec/ipsec_rcv.c	Mon Jul  2 20:42:15 2001
@@ -77,6 +77,7 @@
 int sysctl_ipsec_inbound_policy_check = 1;
 
 #ifdef CONFIG_IPSEC_ESP
+extern void des_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, int);
 extern void des_ede3_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, caddr_t, caddr_t, int);
 #endif /* !CONFIG_IPSEC_ESP */
 #if defined(CONFIG_IPSEC_ESP) || defined(CONFIG_IPSEC_AH)
@@ -1026,6 +1027,7 @@
 #ifdef CONFIG_IPSEC_ESP
 		case IPPROTO_ESP:
 			switch(tdbp->tdb_encalg) {
+			case ESP_DES:
 			case ESP_3DES:
 				iv[0] = *((__u32 *)(espp->esp_iv)    );
 				iv[1] = *((__u32 *)(espp->esp_iv) + 1);
@@ -1043,6 +1045,23 @@
 			ilen -= esphlen;
 			
 			switch(tdbp->tdb_encalg) {
+                       case ESP_DES:
+                               if ((ilen) % 8) {
+                                       tdbp->tdb_encsize_errs += 1;
+                                       spin_unlock(&tdb_lock);
+                                       printk("klips_error:ipsec_rcv: "
+                                              "got packet with esplen = %d from %s -- should be on 8 octet boundary, packet dropped\n",
+                                              ilen,
+                                              ipaddr_txt);
+                                       if(stats) {
+                                               stats->rx_errors++;
+                                       }
+                                       goto rcvleave;
+                               }
+                               des_cbc_encrypt(idat, idat, ilen,
+                                                    tdbp->tdb_key_e,
+                                                    (caddr_t)iv, 0);
+                               break;
 			case ESP_3DES:
 				if ((ilen) % 8) {
 					tdbp->tdb_encsize_errs += 1;
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/ipsec_tunnel.c freeswan-1.91/klips/net/ipsec/ipsec_tunnel.c
--- freeswan-1.91.orig/klips/net/ipsec/ipsec_tunnel.c	Thu Jun 14 15:35:10 2001
+++ freeswan-1.91/klips/net/ipsec/ipsec_tunnel.c	Mon Jul  2 20:48:51 2001
@@ -103,6 +103,7 @@
 #ifdef MSS_HACK
 #include <net/tcp.h>		/* TCP options */
 #endif	/* MSS_HACK */
+extern void des_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, int);
 extern void des_ede3_cbc_encrypt(caddr_t, caddr_t, int, caddr_t, caddr_t, caddr_t, caddr_t, int);
 static __u32 zeroes[64];
 
@@ -1065,6 +1066,11 @@
 #ifdef CONFIG_IPSEC_ESP
 			case IPPROTO_ESP:
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+					headroom += sizeof(struct esp);
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					headroom += sizeof(struct esp);
@@ -1350,6 +1356,11 @@
 #ifdef CONFIG_IPSEC_ESP
 			case IPPROTO_ESP:
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+					headroom += sizeof(struct esp);
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					headroom += sizeof(struct esp);
@@ -1447,6 +1458,16 @@
 				espp->esp_rpl = htonl(++(tdbp->tdb_replaywin_lastseq));
 				
 				switch(tdbp->tdb_encalg) {
+#if defined(CONFIG_IPSEC_ENC_DES)
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+#endif /* CONFIG_IPSEC_ENC_DES */
+					iv[0] = *((__u32*)&(espp->esp_iv)    ) =
+						((__u32*)(tdbp->tdb_iv))[0];
+					iv[1] = *((__u32*)&(espp->esp_iv) + 1) =
+						((__u32*)(tdbp->tdb_iv))[1];
+					break;
+#endif /* defined(CONFIG_IPSEC_ENC_DES) */
 #if defined(CONFIG_IPSEC_ENC_3DES)
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
@@ -1478,6 +1499,13 @@
 				iph->protocol = IPPROTO_ESP;
 				
 				switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+					des_cbc_encrypt(idat, idat, ilen,
+							     (caddr_t)tdbp->tdb_key_e,
+							     (caddr_t)iv, 1);
+					break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
 					des_ede3_cbc_encrypt(idat, idat, ilen,
@@ -1494,6 +1522,17 @@
 				}
 				
 				switch(tdbp->tdb_encalg) {
+#if defined(CONFIG_IPSEC_ENC_DES)
+#ifdef CONFIG_IPSEC_ENC_DES
+				case ESP_DES:
+#endif /* CONFIG_IPSEC_ENC_DES */
+					/* XXX update IV with the last 8 octets of the encryption */
+					((__u32*)(tdbp->tdb_iv))[0] =
+						((__u32 *)(idat))[(ilen >> 2) - 2];
+					((__u32*)(tdbp->tdb_iv))[1] =
+						((__u32 *)(idat))[(ilen >> 2) - 1];
+					break;
+#endif /* defined(CONFIG_IPSEC_ENC_DES) */
 #if defined(CONFIG_IPSEC_ENC_3DES)
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case ESP_3DES:
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/ipsec_xform.c freeswan-1.91/klips/net/ipsec/ipsec_xform.c
--- freeswan-1.91.orig/klips/net/ipsec/ipsec_xform.c	Thu Jun 14 15:35:11 2001
+++ freeswan-1.91/klips/net/ipsec/ipsec_xform.c	Tue Jul  3 01:24:29 2001
@@ -69,6 +69,9 @@
 { XF_IP4,		0,		"IPv4_Encapsulation"},
 { XF_AHHMACMD5,		XFT_AUTH,	"HMAC_MD5_Authentication"},
 { XF_AHHMACSHA1,	XFT_AUTH,	"HMAC_SHA-1_Authentication"},
+{ XF_ESPDES,           XFT_CONF,       "DES_Encryption"},
+{ XF_ESPDESMD596,      XFT_CONF,       "DES-MD5-96_Encryption"},
+{ XF_ESPDESSHA196,     XFT_CONF,       "DES-SHA1-96_Encryption"},
 { XF_ESP3DES,		XFT_CONF,	"3DES_Encryption"},
 { XF_ESP3DESMD596,	XFT_CONF,	"3DES-MD5-96_Encryption"},
 { XF_ESP3DESSHA196,	XFT_CONF,	"3DES-SHA1-96_Encryption"},
@@ -313,9 +316,9 @@
 	struct xformsw *xsp;
 	int error = 0;
         int i;
-#if defined(CONFIG_IPSEC_ENC_3DES)
+#if defined(CONFIG_IPSEC_ENC_DES) || if defined(CONFIG_IPSEC_ENC_3DES)
         int error;
-#endif /* CONFIG_IPSEC_ENC_3DES */
+#endif /* CONFIG_IPSEC_ENC_{3,}DES */
 
         char sa[SATOA_BUF];
         size_t sa_len;
@@ -568,6 +571,16 @@
 #endif /* CONFIG_IPSEC_AH */
 
 #ifdef CONFIG_IPSEC_ESP
+#ifdef CONFIG_IPSEC_ENC_DES
+                       case XF_ESPDES:
+#ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
+                       case XF_ESPDESMD596:
+#endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
+#ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
+                       case XF_ESPDESSHA196:
+#endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
+#endif /* CONFIG_IPSEC_ENC_DES */
+
 #ifdef CONFIG_IPSEC_ENC_3DES
 			case XF_ESP3DES:
 #ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
@@ -607,6 +620,10 @@
 				case XF_ESP3DES:
 				case XF_ESP3DESMD596:
 				case XF_ESP3DESSHA196:
+				case XF_ESPDES:
+				case XF_ESPDESMD596:
+				case XF_ESPDESSHA196:
+
 					if((tdbp->tdb_iv = (caddr_t)
 					   kmalloc((tdbp->tdb_iv_size = EMT_ESPDES_IV_SZ), GFP_ATOMIC)) == NULL) {
 						SENDERR(ENOMEM);
@@ -618,6 +635,44 @@
 				}
 
 				switch(alg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+                               case XF_ESPDES:
+                               case XF_ESPDESMD596:
+                               case XF_ESPDESSHA196:
+                                       tdbp->tdb_encalg = ESP_DES;
+                               
+                                       if (ed->eme_klen != EMT_ESPDES_KEY_SZ) {
+                                               KLIPS_PRINT(debug_esp,
+                                                           "klips_debug:tdb_init: "
+                                                           "incorrect encryption key size: %d -- must be %d octets (bytes)\n",
+                                                           ed->eme_klen, EMT_ESPDES_KEY_SZ);
+                                               SENDERR(EINVAL);
+                                       }
+
+                                       tdbp->tdb_key_bits_e = ed->eme_klen;
+
+                                       if((tdbp->tdb_key_e = (caddr_t)
+                                          kmalloc((tdbp->tdb_key_e_size = sizeof(struct des_eks)),
+                                                  GFP_ATOMIC)) == NULL) {
+                                               SENDERR(ENOMEM);
+                                       }
+
+                                               error = des_set_key((caddr_t)(ed->eme_key),
+                                                                   (caddr_t)&((struct des_eks*)(tdbp->tdb_key_e)));
+                                               if (error == -1)
+                                                       printk("klips_debug:tdb_init: "
+                                                              "parity error in des key\n");
+                                               else if (error == -2)
+                                                       printk("klips_debug:tdb_init: "
+                                                              "illegal weak des key\n");
+                                               if (error) {
+                                                       memset(tdbp->tdb_key_e, 0, sizeof(struct des_eks));
+                                                       kfree(tdbp->tdb_key_e);
+                                                       SENDERR(EINVAL);
+                                               }
+
+                                       break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 #ifdef CONFIG_IPSEC_ENC_3DES
 				case XF_ESP3DES:
 				case XF_ESP3DESMD596:
@@ -672,6 +727,7 @@
 
 				switch(alg) {
 #ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
+				case XF_ESPDESMD596:
 				case XF_ESP3DESMD596:
 				case XF_ESPNULLMD596:
 				{
@@ -748,6 +804,7 @@
 #ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
 				case XF_ESPNULLSHA196:
 				case XF_ESP3DESSHA196:
+				case XF_ESPDESSHA196:
 				{
 					SHA1_CTX *ictx;
 					SHA1_CTX *octx;
@@ -816,6 +873,7 @@
 					break;
 				}
 #endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
+				case XF_ESPDES:
 				case XF_ESP3DES:
 					tdbp->tdb_authalg = AH_NONE;
 					break;
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/ipsec_xform.h freeswan-1.91/klips/net/ipsec/ipsec_xform.h
--- freeswan-1.91.orig/klips/net/ipsec/ipsec_xform.h	Thu Jun 14 15:35:11 2001
+++ freeswan-1.91/klips/net/ipsec/ipsec_xform.h	Mon Jul  2 20:58:42 2001
@@ -22,16 +22,22 @@
 #define XF_IP4			1	/* IPv4 inside IPv4 */
 #define XF_AHMD5		2	/* AH MD5 */
 #define XF_AHSHA		3	/* AH SHA */
+#define XF_ESPDESOLD		4       /* old ESP DES-CBC */
 #define XF_ESP3DES		5	/* ESP DES3-CBC */
 #define XF_AHHMACMD5		6	/* AH-HMAC-MD5 with opt replay prot */
 #define XF_AHHMACSHA1		7	/* AH-HMAC-SHA1 with opt replay prot */
+#define XF_ESPDESMD5           8       /* DES, HMAC-MD-5, 128-bits of authentication */
 #define XF_ESP3DESMD5		9	/* triple DES, HMAC-MD-5, 128-bits of authentication */
 #define	XF_ESP3DESMD596		10	/* triple DES, HMAC-MD-5, 96-bits of authentication */
+#define XF_ESPDESMD596          11      /* DES, HMAC-MD-5, 96-bits of authentication */
 #define	XF_ESPNULLMD596		12	/* NULL, HMAC-MD-5 with 96-bits of authentication */
 #define	XF_ESPNULLSHA196	13	/* NULL, HMAC-SHA-1 with 96-bits of authentication */
 #define	XF_ESP3DESSHA196	14	/* triple DES, HMAC-SHA-1, 96-bits of authentication */
-#define XF_IP6			15	/* IPv6 inside IPv6 */
-#define XF_COMPDEFLATE		16	/* IPCOMP deflate */
+#define XF_ESPDESSHA196         15      /* DES, HMAC-SHA-1, 96-bits of authentication */
+#define XF_ESPDES               16      /* ESP DES */
+
+#define XF_IP6			17	/* IPv6 inside IPv6 */
+#define XF_COMPDEFLATE		18	/* IPCOMP deflate */
 
 #define XF_CLR			126	/* Clear SA table */
 #define XF_DEL			127	/* Delete SA */
@@ -44,16 +50,20 @@
 #define AH_NONE                  0
 #define AH_MD5                   2
 #define AH_SHA                   3
+#define AH_DES                   3
 
 /* IPsec ESP transform values */
 
 #define ESP_NONE		 0
+#define ESP_DES_IV64             1
+#define ESP_DES                  2
 #define ESP_3DES                 3
 #define ESP_RC5                  4
 #define ESP_IDEA                 5
 #define ESP_CAST                 6
 #define ESP_BLOWFISH             7
 #define ESP_3IDEA                8
+#define ESP_DES_IV32             9
 #define ESP_RC4                 10
 #define ESP_NULL                11
 
@@ -179,6 +189,7 @@
 		((x)->tdb_encalg == SADB_X_CALG_DEFLATE ? \
 		 "_DEFLATE" : "_UNKNOWN_comp") : \
 	(x)->tdb_encalg == ESP_NONE ? "" : \
+	(x)->tdb_encalg == ESP_DES ? "_DES" : \
 	(x)->tdb_encalg == ESP_3DES ? "_3DES" : \
 	"_UNKNOWN_encr", \
 	(x)->tdb_authalg == AH_NONE ? "" : \
